<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { inject, ref } from 'vue';
import { storeToRefs } from 'pinia';
import { usePreviewStore } from '@/stores/preview';
import CopyModal from '@/components/preview/shared/CopyModal.vue';
import Comments from '@/components/preview/shared/CommentSidebar.vue';
import Column from '@/components/preview/schedule/Column.vue';
import Modal from '@/components/general/Modal.vue';

const store = usePreviewStore();
const { style, data, headline, subheadline, postIndex, columnIndex, isExport } = storeToRefs(store);

const configuration = inject<any>('configuration');

const isCopyModalOpen = ref(false);
const showCopyModal = (value: boolean) => {
    isCopyModalOpen.value = value;
};

const isHeadlineModalOpen = ref(false);
const showHeadlineModal = (value: boolean) => {
    isHeadlineModalOpen.value = value;
}

const isSubHeadlineModalOpen = ref(false);
const showSubHeadlineModal = (value: boolean) => {
    isSubHeadlineModalOpen.value = value;
}

const close = () => {
    postIndex.value = -1;
    columnIndex.value = -1;
};

</script>
<template>
    <div :class="style?.font ? style.font : ''" class="min-w-screen h-screen">
        <nav class="bg-white min-h-20 max-h-20 h-20 flex flex-row">
            <div class="pl-7 h-20 pt-5">
                <div :class="['select-none', style?.font ? style.font : '']" class="flex flex-col">
                    <Tooltip :tooltip="headline" :offset="10" width="max-w-96">
                        <div class="text-2xl line-clamp-1 text-ellipsis w-full h-8">{{ headline }}</div>
                    </Tooltip>
                    <div class="w-fit">
                        <Tooltip :tooltip="subheadline" placement="bottom" width="max-w-96">
                            <div class="line-clamp-1 text-ellipsis h-6">{{ subheadline }}</div>
                        </Tooltip>
                    </div>
                </div>
            </div>
            <div class="ml-auto min-w-20px p-4 pr-7" v-if="!isExport">
                <Tooltip :tooltip="$t('adminMenu.copy.label')">
                    <button
                        class="size-12 hover:bg-gray-200 text-gray-500 rounded-md block text-center align-middle leading-[48px] text-2xl hover:no-underline"
                        @click="showCopyModal(true)"><i class="ri-file-copy-line leading-12 align-middle"></i></button>
                </Tooltip>
                <CopyModal v-if="isCopyModalOpen" @close="showCopyModal(false)" />
            </div>
        </nav>
        <div id="content" class="h-full overflow-auto p-2 max-h-[calc(100dvh-80px)] "
            :style="{ background: style != null && style.backgroundImage != null ? `url(${configuration.apiServer}` + style.backgroundImage + ')' : (style != null && style.backgroundColor != null ? style.backgroundColor : 'white') }">
            <div class="flex flex-row flex-nowrap w-full gap-10 p-4">
                <Column :column="element" :columnIndex="index" v-for="element, index in data" />
            </div>
            <Comments v-if="postIndex >= 0 && columnIndex >= 0" @close="close" />
        </div>
        <Modal v-if="isHeadlineModalOpen" @close="showHeadlineModal(false)" :labelCancel="$t('general.buttons.close')">
            <div class="text-xl" v-html="headline"></div>
        </Modal>
        <Modal v-if="isSubHeadlineModalOpen" @close="showSubHeadlineModal(false)"
            :labelCancel="$t('general.buttons.close')">
            <div class="text-lg" v-html="subheadline"></div>
        </Modal>
    </div>
</template>
<style scoped>
.subline {
    overflow: hidden;
    text-overflow: ellipsis;
    word-wrap: break-word;
    display: block;
    line-height: 1em;
    /* a */
    max-height: 3em;
    padding-bottom: 4px;
}
</style>
